import zipfile
import pygame
from pygame.locals import *
import shutil
import os
import ConfigFile
from distutils import dir_util

fps = 30.0
pygame.init()
window = pygame.display.set_mode((320,240))
pygame.display.set_caption("CBZ-Reader")
screen = pygame.display.get_surface()
pygame.mouse.set_visible(0)
font = pygame.font.SysFont("arial", 15)
joy=pygame.joystick.Joystick(0)
joy.init()

ZoomLevel=1.0
PageNum=0
ViewPos=[0,0]
CBZ=None
RotVal=0
imgPage=None
CBZIndex=[]
NumPages=0
PicExt=[".jpg",".png",".gif",".bmp",".jpeg"]
CBZ_File=""
Config=dict()
PageLoaded=False

def End():
	global Config
	if Config.has_key(CBZ_File):
		Config[CBZ_File]["Page"]=PageNum
		Config[CBZ_File]["Zoom"]=ZoomLevel
		Config[CBZ_File]["Rotate"]=RotVal
		Config[CBZ_File]["ViewX"]=ViewPos[0]
		Config[CBZ_File]["ViewY"]=ViewPos[1]
	else:
		ConfigSection=dict()
		ConfigSection["Page"]=PageNum
		ConfigSection["Zoom"]=ZoomLevel
		ConfigSection["Rotate"]=RotVal
		ConfigSection["ViewX"]=ViewPos[0]
		ConfigSection["ViewY"]=ViewPos[1]
		Config[CBZ_File]=ConfigSection
	ConfigFile.Write("books.conf",Config)
	quit()

def LoadPage():
	global imgPage
	global PageLoaded
	try:
		imgPage=pygame.image.load("cache/"+CBZIndex[PageNum]).convert()
		PageLoaded=True
	except pygame.error:
		imgPage=font.render("Loading \""+CBZIndex[PageNum]+"\"...",True,(0,255,0))
		PageLoaded=False
	imgPage=pygame.transform.rotate(imgPage,RotVal)

def ZoomPage(Reset=False):
	global imgPage
	if ZoomLevel!=1.0 or Reset:
		LoadPage()
		try:
			imgPage=pygame.transform.scale(imgPage,(int(imgPage.get_width()*ZoomLevel),int(imgPage.get_height()*ZoomLevel)))
		except pygame.error:
			pass

def InputView():
	global ZoomLevel
	global PageNum
	global ViewPos
	global RotVal
	events = pygame.event.get()
	for event in events:
		if event.type==JOYBUTTONDOWN:
			if event.button==4:
				if PageNum>0:
					PageNum-=1
					ZoomPage(True)
			if event.button==5:
				if PageNum<NumPages:
					PageNum+=1
					ZoomPage(True)
			if event.button==1:
				RotVal+=90
				if RotVal==360: RotVal=0
				ZoomPage(True)
			if event.button==2:
				ZoomLevel=1.0
				ViewPos=[0,0]
				ZoomPage(True)
	if joy.get_button(0):
		if ZoomLevel>0.1:
			ZoomLevel-=0.1
			ZoomPage()
	elif joy.get_button(3):
		ZoomLevel+=0.1
		ZoomPage()
	if joy.get_button(6):
		End()
	if joy.get_axis(0)>-0.75:
		ViewPos[0]-=40
	elif joy.get_axis(0)>-0.50:
		ViewPos[0]-=20
	if joy.get_axis(0)<0.75:
		ViewPos[0]+=40
	elif joy.get_axis(0)<0.50:
		ViewPos[0]+=20
	if joy.get_axis(1)>-0.75:
		ViewPos[1]-=40
	elif joy.get_axis(0)>-0.50:
		ViewPos[1]-=20
	if joy.get_axis(1)<0.75:
		ViewPos[1]+=40
	elif joy.get_axis(1)<0.50:
		ViewPos[1]+=20

def CachePage():
	if not os.path.exists("cache/"+CBZIndex[PageNum]):
		try:
			dir_util.create_tree("cache/",[CBZIndex[PageNum]])
			PageData=CBZ.read(CBZIndex[PageNum])
			PageCache=open("cache/"+CBZIndex[PageNum],"wb")
			PageCache.write(PageData)
			PageCache.close()
		except:
			pass
	pygame.time.delay(100)

def ViewPage():
	screen.fill((0,0,0))
	screen.blit(imgPage,(ViewPos[0],ViewPos[1]))
	lblPage=font.render(str(PageNum+1)+"/"+str(NumPages+1),True,(0,0,0))
	pygame.draw.rect(screen,(255,255,255),(320-lblPage.get_width(),240-lblPage.get_height(),lblPage.get_width(),lblPage.get_height()),0)
	screen.blit(lblPage,(320-lblPage.get_width(),240-lblPage.get_height()))
	
def InitCBZ():
	global CBZ_File
	global CBZ
	global CBZIndex
	global NumPages
	global Config
	global PageNum
	global ZoomLevel
	global ViewPos
	global RotVal
	
	if os.path.exists("books.conf"):
		Config=ConfigFile.Read("books.conf")
	else:
		Config=dict()
	if Config.has_key(CBZ_File):
		if Config[CBZ_File].has_key("Page"):
			PageNum=int(Config[CBZ_File]["Page"])
		if Config[CBZ_File].has_key("Zoom"):
			ZoomLevel=float(Config[CBZ_File]["Zoom"])
		if Config[CBZ_File].has_key("Rotate"):
			RotVal=int(Config[CBZ_File]["Rotate"])
		if Config[CBZ_File].has_key("ViewX"):
			ViewPos[0]=int(Config[CBZ_File]["ViewX"])
		if Config[CBZ_File].has_key("ViewY"):
			ViewPos[1]=int(Config[CBZ_File]["ViewY"])
	
	CBZ=zipfile.ZipFile(CBZ_File,"r")
	
	CBZIndex=CBZ.namelist()
	_CBZIndex=[]
	for Page in CBZIndex:
		if Page[len(Page)-4:].lower() in PicExt: _CBZIndex.append(Page)
		if Page[len(Page)-5:].lower() in PicExt: _CBZIndex.append(Page)
	CBZIndex=_CBZIndex
	CBZIndex.sort()
	
	ClearCache()
	CachePage()

	LoadPage()
	ZoomPage()
	ViewPage()
	
	NumPages=len(CBZIndex)-1

def walkfiles(thisdir):
	join = os.path.join
	isdir = os.path.isdir
	isfile = os.path.isfile
	for child in os.listdir(thisdir):
		thischild = join(thisdir, child)
		if isfile(thischild):
			yield thischild
		elif isdir(thischild):
			for f in walkfiles(thischild):
				yield f

def ClearCache(Force=False):
	if Force:
		dir_size=51
	else:
		dir_size=sum([os.path.getsize(f) for f in walkfiles("cache")])/(1024**2)
	if dir_size>50:
		try:
			shutil.rmtree("cache",True)
			os.mkdir("cache")
		except:
			pass

f=open(".load_book","r")
CBZ_File=f.readline().replace("\n","")
f.close()

InitCBZ()
while 1:
	ClearCache()
	CachePage()
	InputView()
	if ViewPos[1]<240-imgPage.get_height(): ViewPos[1]=240-imgPage.get_height()
	if ViewPos[0]<320-imgPage.get_width(): ViewPos[0]=320-imgPage.get_width()
	if ViewPos[1]>0: ViewPos[1]=0
	if ViewPos[0]>0: ViewPos[0]=0
	if not PageLoaded: ZoomPage()
	ViewPage()
	pygame.display.flip()
	pygame.display.update()
	pygame.time.delay(int(1000 * 1.0/fps))
